<template lang="pug">
<b-modal :id="'edit_product_modal_'+ mode + '_' + index" hide-header ok-only size="lg" modal-class="edit_modal edit_product_modal_modal">
    <b-tabs pills card vertical class="edit_product_modal" nav-wrapper-class="edit_product_modal__sidebar">
        <b-tab title="商品列表" active class="edit_product_modal__page">
            b-form-group(
                :id="'edit_product_modal_' + mode + '_' + index + 'input-group'",
                label="開啟商品 :",
                :label-for="'edit_product_modal_' + mode + '_' + index + 'input'"
            )
                b-form-select(
                    :id="'edit_product_modal_' + mode + '_' + index + 'input'",
                    v-model="product",
                    :options="products",
                    @change="getProduct"
                )
            b-table-simple(hover, responsive)
                colgroup <col><col>
                colgroup <col><col><col>
                colgroup <col><col>
                colgroup <col><col>
                b-thead(head-variant="dark")
                    b-tr.edit_product_modal__page_table__tr(role="row")
                        b-th.edit_product_modal__page_table__th(
                            role="columnheader",
                            scope="col",
                            tabindex="0",
                            aria-colindex="1"
                        ) 圖片
                        b-th.edit_product_modal__page_table__text(
                            role="columnheader",
                            scope="col",
                            tabindex="0",
                            aria-colindex="2"
                        ) 內文
                        b-th(
                            role="columnheader",
                            scope="col",
                            tabindex="0",
                            aria-colindex="3"
                        ) 優惠價格
                        b-th(
                            role="columnheader",
                            scope="col",
                            tabindex="0",
                            aria-colindex="4"
                        ) 售價
                        b-th(
                            role="columnheader",
                            scope="col",
                            tabindex="0",
                            aria-colindex="5"
                        ) 刪除
                draggable(
                    v-model="cards",
                    tag="tbody",
                    role="rowgroup",
                    animation="150",
                    handle=".edit_product_modal__page_table__handle",
                    ghostClass="edit_product_modal__page_table__ghost"
                )
                    b-tr.edit_product_modal__page_table__tr(
                        role="row",
                        v-for="(item, index) in cards",
                        :key="index"
                    )
                        b-td.edit_product_modal__page_table__img(
                            :aria-colindex="1",
                            role="cell"
                        )
                            b-img.edit_product_modal__page_table__handle.mr-1.p-1(
                                src="@/assets/svg/menu.svg",
                                width="20"
                            )
                            b-img.edit_product_modal__page_img(:src="item.product_image")
                        b-td.edit_product_modal__page_table__text(
                            :aria-colindex="2",
                            role="cell"
                        )
                            | {{ item.product_name }}
                        b-td(:aria-colindex="3", role="cell")
                            | {{ item.price_list }}
                        b-td(:aria-colindex="4", role="cell")
                            | {{ item.price_selling }}
                        b-td(:aria-colindex="5", role="cell")
                            b-button(
                                variant="danger",
                                squared,
                                @click="deleteProduct(index)"
                            ) 刪除
    </b-tab>
        // <b-tab title="商品更新" class="edit_car_modal__page">

        // </b-tab>
    </b-tabs>
</b-modal>
</template>

<script>
import draggable from "vuedraggable";
export default {
    data() {
        return {
            short_col: 2,
            long_col: 3,
            product: null,
            products: [{
                    text: "請選擇商品",
                    value: null,
                },
                {
                    text: "我的產品 - 1",
                    value: 1,
                },
            ],
        };
    },
    components: {
        draggable,
    },
    props: {
        mode: {
            type: String,
            default: "",
        },
        index: {
            type: [String, Number],
            default: "",
        },
        default_content: {
            type: [Object, Array],
            default: () => [],
        },
    },
    computed: {
        cards: {
            get() {
                let index = this.$store.state.secondaryComponent
                    .map((i) => i.id)
                    .indexOf(this.index);
                let check = this.$store.state.secondaryComponent[index];
                return check ?
                    this.$store.state.secondaryComponent[index].content.products :
                    [];
            },
            set(value) {
                this.$store.commit("UPDATE_SECONDARYCOMPONENT_VALUE", {
                    key: this.index,
                    second_key: "products",
                    val: value,
                });
            },
        },
    },
    methods: {
        deleteProduct(idx) {
            this.$store.commit("DELETE_SECONDARYCOMPONENT_PRODUCT_VALUE", {
                key: this.index,
                product_index: idx,
            });
        },
        getProduct() {
            let id = this.$route.query.shop_id;
            let index = this.index;
            switch (this.product) {
                case 1:
                    this.$store.dispatch("getProduct", {
                        id,
                        index,
                    });
                    break;
            }
        },
    },
};
</script>

<style lang="scss">
@mixin editCardModalPageTableText($elem, $elem2) {
    #{$elem}.edit_product_modal__page_table__#{$elem2} {
        @content;
    }
}

@include editCardModalPageTableText(td, img) {
    display: flex;
    justify-content: center;
    align-content: center;
}

@include editCardModalPageTableText(td, text) {
    max-height: 90px;
    font-size: 14px;
    overflow: hidden;
}

th {
    &:focus {
        outline-color: transparent !important;
        outline-width: 0px !important;
    }
}

.edit_product_modal {
    position: relative;
    width: 100%;
    height: 420px;
    display: flex;
    align-items: stretch;

    &__sidebar {
        position: relative;
        background-color: #6c757d;

        .nav-link {
            &.active {}
        }
    }

    &__page {
        max-width: 100%;
        max-height: 420px;
        overflow: scroll;

        &_img {
            width: 110px;
            height: auto;
        }

        &_table {
            &__tr {
                text-align: center;
                vertical-align: middle;
            }

            &__text {
                width: 210px !important;
            }

            &__ghost {
                background-color: #55555540;

                td {
                    opacity: 0;
                }
            }
        }
    }
}
</style>
